function ddMenu_events_init(){ //drop-down menu related event initialization
	
	//hide coordinateDiv for first run
	$('#coordinateDiv').fadeOut(0);
	
	$('.ddButton').each(function(){ //each ddButton
	
		var $this = $(this);
		
		$this.on('click', function(){ //on click
		
			ddMenu_hideExcept($this);
			if ( $this.children('.ddMenu').css('display') == 'block') ddMenu_hide($this);
			else ddMenu_show($this);
			
		});
	});			
	
	$('.ddMenu').on('click', function(e){ e.stopPropagation(); }); //stop dropdown menu child event propagation
	
	//------ icon events --------
	
	$('#iconWrapper')
		.on('click', '.menuIcon', function(){
			
			$this = $(this); //cache jQuery object
			
			switch ($this.attr('id')){
			
				case 'plusIcon': scaleMap(1.5, true); break;
				
				case 'minusIcon': scaleMap(0.5, true); break;
				
				case 'fitIcon': scaleMap(1); break;
				
				case 'helpIcon': return true;; //do nothing, it is an URL
				
				case 'distanceIcon':
					headingCalc.state = 0; //disable heading calculator
					if (distanceCalc.state == 0) distanceCalc.state = 1;
					else distanceCalc.state = 0;
					distanceCalculator(-1);
				break;
				
				case 'headingIcon':
					distanceCalc.state = 0; //disable distance calculator
					if (headingCalc.state == 0) headingCalc.state = 1;
					else headingCalc.state = 0;
					headingCalculator(-1);
				break;
				
				case 'coordIcon': //toggle menubar in-game coordinate display
					$('#coordinateDiv').fadeToggle(400);
					freezeInGameCoordinates = 0; //disable freeze if toggled
				break;
				
				/*case 'Icon':
				break;*/
				
				default: e('Unknown button!');
				break;
			
			} //switch()
			
		})
		
		.on('mouseover', '.menuIcon', function(){ //display mouselabels
			displayMouseLabel($(this).data('description'));
		})
		
		.on('mouseout', '.menuIcon', hideMouseLabel); //hide mouselabels
		
	$('#searchInput').on('keypress', function(e){ //if enter pressed in the search input
		if (e.which == 13) searchForObject( $('#searchInput').val() );		
		return true;
	});
	
	$('#searchButton').on('click', function(){ //search if the button is pressed
		searchForObject( $('#searchInput').val() );
	});
		
	$('#searchHelp')
		.on('mouseenter', function(){ //display search help
			displayMouseLabel('<b>Search help</b><br /><br />Type a runway name [or partial name], then press Search or Enter.<br /><br />Type an integer to search for objectID.');
		})
		.on('mouseleave', hideMouseLabel);
	
	
	//switch on/off objects
	$('.tObjectCheckbox').on('click', function(){
		
		var $this = $(this);
		var regex = new RegExp('^' + String($this.data('objecttype')), '');
		var thisChecked = $this.is(':checked');
		
		$('.tLabelCheckbox').each(function(){ //toggle label checkboxes
			if ($this.data('objecttype') == $(this).data('objecttype') )
				$(this).prop('checked', thisChecked);
		});
		
		
		for (var i=0; i<objects_count; i++) //iterate all objects and attach/remove type			
			if ( String(objects[i].type).match(regex) != null )				
				if (thisChecked)
					objects[i].attach();
				else
					objects[i].remove();	
	});
	
	
	//show/hide labels
	$('.tLabelCheckbox').on('click', function(){
		
		var $this = $(this);
		var type = $this.data('objecttype');
		var tregex = new RegExp(type, '');
		var error = false;
		
		
		$('.tObjectCheckbox').each(function(){ //check if this object is enabled
		
			if ($(this).data('objecttype') == type && $(this).is(':checked') !== true ){
			
				e('Enable the object first to display their labels!');
				$this.prop('checked', false);
				error = true;
				
			} //if
			
		});
		
		if (error) return;
		
		
		$('.mapText').each(function(){ //toggle labels
			
			if ( String( $(this).data('objecttype') ).match(tregex) != null )
				if ( $this.is(':checked') )
					$(this).css('display', 'block');
				else
					$(this).css('display', 'none');
			
		});
		
	});
	
} //ddMenu_events_init()

//---------------------------------------------

function ddMenu_show(ddButton){ //drop-down menu function to slide down the menu
	
	var ddMenu = ddButton.children('div.ddMenu');
	
	if (ddMenu.css('display') == 'block') return;
	
	var left = ddButton.offset().left - 12;
	var top = ddButton.offset().top + ddButton.outerHeight() - 2;
	
	ddMenu
		.css({ 'left': left + 'px', 'top': top + 'px' })
		.slideDown(200);
		
	ddButton.find('img').rotate({animateTo: 180, duration: 900});
	
} //ddMenu_show()

//--------------------------------------------

function ddMenu_hide(ddButton){ //slideUp (hide) the menu

	ddButton.children('.ddMenu').slideUp(200);
	ddButton.find('img').rotate({animateTo: 0, duration: 900});

} //ddMenu_hides()

//--------------------------------------------

function ddMenu_hideExcept(ddButton){
	
	$('.ddButton').each(function(){
	
		if ($(this).attr('id') != ddButton.attr('id'))
			ddMenu_hide($(this));
			
	});
}

//--------------------------------------------

function setSearchResult(data){

	ddMenu_show($('#ddButton_search'));
	$('#searchResult').html(data);
	
} //setSearchResult()

//--------------------------------------------

function appendSearchResult(data){

	ddMenu_show($('#ddButton_search'));
	$('#searchResult').append(data);
	
} //setSearchResult()