function dragMap(e){
				
	var currentMapOffset = $mw.offset();
	
	$mw.offset({
		"left": currentMapOffset.left + e.pageX - mouseDragStartX,
		"top": currentMapOffset.top + e.pageY - mouseDragStartY
	});

} // dragMap()

//--------------------------------------------

function d(msg){
	$("#debug").css("display", "block").prepend(msg+"<br />");
}

//--------------------------------------------

function e(msg){

	$('#errorMessage').html(msg);
	$('#errorMessageWrapper').fadeIn(300);

} //error display function

//--------------------------------------------


function scaleMap(relativeFactor, disableMouseTracking){
	
	if (mapScale * relativeFactor > 38) return;
	if ($mw.height() < 500 && relativeFactor < 1) return;
	
	if (relativeFactor <= 0) return e('relativeFactor<=0 error');
	
	if (relativeFactor == 1){ //scale to fit	
		
		var newMapSize = zoomToFitScale * $(window).height();
		mapScale = newMapSize / 1000;
		
		$mw
			.width(newMapSize)
			.height(newMapSize)
			.offset({
				"left": - (newMapSize - $(window).width() ) * 0.5,
				"top": - northestObjY * mapScale
			});
		
		map.scaleAll(mapScale);
		map.renderfix(); //fix rendering issue in chrome
		
		return;
	} //if
	
	
	//reposition commands
	mapScale *= relativeFactor; //update global scale variable
	
	var lastMapSize = $mw.width();
	var mapOffset = $mw.offset();
	var lastMapX = mapOffset.left;
	var lastMapY = mapOffset.top;
	var newMapSize = 1000 * mapScale;
	
	if (typeof(disableMouseTracking) != 'undefined'){ //if user is using Plus and Minus buttons
		
		var windowCenterX = $(window).width()/2;
		var windowCenterY = $(window).height()/2;
		var mapCenterXp = (windowCenterX - lastMapX) / lastMapSize;
		var mapCenterYp = (windowCenterY - lastMapY) / lastMapSize;
		
		$mw
			.width(newMapSize)
			.height(newMapSize)
			.offset({
				"left": windowCenterX - mapCenterXp*newMapSize,
				"top": windowCenterY - mapCenterYp*newMapSize
			});
			
		
	} else { //reposition under cursor
	
		var mouseMapXp = (gMouseX - lastMapX) / lastMapSize;
		var mouseMapYp = (gMouseY - lastMapY) / lastMapSize;
		
		//reposition
		//var newMapSize = /*$map*/$mw.width();
		var newMapX = gMouseX - mouseMapXp * newMapSize;
		var newMapY = gMouseY - mouseMapYp * newMapSize;
		
		$mw
			.width(newMapSize)
			.height(newMapSize)
			.offset({
				"left": newMapX,
				"top": newMapY
			});	
	
	} //else
	
	map.scaleAll(mapScale);
	
	map.renderfix(); //fix rendering issue in chrome

	
} //scaleMap()

//-----------------------------------


function setLabelHighlight(labelObject, state){
	
		if (state)
			labelObject
				.addClass('mapTextHover')
				.css('z-index', '51');
		else
			labelObject
				.removeClass('mapTextHover')
				.css('z-index', '50');
	
} //highlightLabel()

//--------------------------------------------

function displayMouseLabel(message){

	/*if (typeof(event) != 'undefined')
		$('#mouseLabel').css({
			'left': (event.pageX + 15) + 'px',
			'top': (event.pageY + 15) + 'px'
		});*/

	$('#mouseLabel')
		.html(message)
		.css('display', 'block');
	
	isMouseLabelVisible = 1;
	
} //displayMouseLabel()

//-----------------------------------------------

function hideMouseLabel(){	
	$('#mouseLabel').css('display', 'none');
	isMouseLabelVisible = 0;
} //hideMouseLabel()

//-----------------------------------------------------

function setLoadingIcon(state){	
	if (state) $('#loading').show();
	else $('#loading').fadeOut(300);	
} //setLoadingIcon()

//-------------------------------------------------------

function searchForObject(keyword){
	
	//setLoadingIcon(true);
	setSearchResult('<img src="img/loading.gif" />');
	
	$.ajax({
		type: "POST",
		url: "php/ajax_search.php",
		data: { "keyword": keyword }
	})
	.done(function(data){ setSearchResult(data); })
	.fail(function(xhr){ setSearchResult('AJAX error, code: ' + xhr.status); })
	.always(function(){ setLoadingIcon(false); });
	
} //searchForObject()

//--------------------------------------------------------

function objectClickHandler(id){
	//distributes functions: search, distance and heading calculation
	
	if (distanceCalc.state) return distanceCalculator(id);
	if (headingCalc.state) return headingCalculator(id);
	
	searchForObject(id);
	
} //objectClickHandler()

//--------------------------------------------------------------

//function from http://snipplr.com/view/66256/
//groups numbers by the thousands
Number.prototype.format = function () {
return this.toString().split(/(?=(?:\d{3})+(?:\.|$))/g).join(' ');
};



//----------------------------------------------------------

function zoomToObject(id){
	
	if (document.getElementById(id) == null) //existence check
		return e('Unable to zoom to deactivated object. Go to "Toggle objects" and activate the appropriate layer.');
	
	mapScale = 1;	
	scaleMap(16, true);	
	
	var $obj = $('#' + id);
	var zoomx = parseFloat($obj.attr('x')) * mapScale;
	var zoomy = parseFloat($obj.attr('y')) * mapScale;
	
	$mw.offset({
		"left": -zoomx + $(window).width()/2,
		"top": -zoomy + $(window).height()/2
	});	
	
} // zoomToObject()

//---------------------------------------------------------------

function calculateZoomToFitVars(){

	e('calculateZoomToFitVars not implemented');

} //calculateZoomToFitScale()

//---------------------------------------------------------------

ctransform = { //coordinate transformation fns
	"toSVG": function(x, y){
		return { 'x': (x+20000)/40, 'y': 1000 - (y+20000)/40 };
	}, //toSVG
	
	"toIG": function(x, y){
		return { 'x': x*40 - 20000, 'y': (1000 - y)*40 - 20000 };
	} //toIG	
};

//-------------------------------------------------------------

//----------------- runway "class" ---------------------

function RunwayClass(id, name, type, orientation, svg_x, svg_y, svg_height, xtp, ytp){
	
	this.id = id;
	this.name = name;
	this.type = type;
	this.orientation = orientation;
	this.svg_x = svg_x;
	this.svg_y = svg_y;
	this.svg_height = svg_height;
	//this.raphaelObject;
	this.xtp = xtp;
	this.ytp = ytp;
	
} //RunwayClass

RunwayClass.prototype.attach = function(){

	this.raphaelObject = map.rect(this.svg_x, this.svg_y, runwayWidth, this.svg_height);
	if (this.orientation != '0') this.raphaelObject.attr('transform', 'r' + this.orientation);
	
	$(this.raphaelObject.node)
		.attr({
			"class": "t"+this.type,
			"id": this.id
		})
		.data("objectid", this.id);
	
	attachMapText(this.id, this.type, this.name, this.xtp, this.ytp);
	
	return this;
	
} //attach()

RunwayClass.prototype.remove = function(){
	
	this.raphaelObject.remove();
	$("#mapText_"+this.id).remove();
	
	return this;
	
} //remove()

//------------- symbol "class" -------------------

function sx4map(x)
{
	xx = (x+20000)/400;
	return xx;
} 


function sy4map(y)
{
	yy = (1000 - ((y + 20000) / 40)  ) / 10;
	return yy;
} 






function SymbolClass(id, name, type, svg_x, svg_y){

	this.id = id;
	this.name = name;
	this.type = type;
	this.svg_x = svg_x;
	this.svg_y = svg_y;
	//this.raphaelObject;
	
	return this;
	
} //SymbolClass()

SymbolClass.prototype.attach = function(firstrun){
	
	this.raphaelObject = map.text(this.svg_x, this.svg_y, obj_symbol_data[this.type].symbol);
	
	var rNode = this.raphaelObject.node;
	var classes = 'symbol t' + this.type;
	
	rNode.setAttribute('font', ''); //opera compatible attribute deletion method
	rNode.setAttribute('style', '');
	rNode.getElementsByTagName('tspan')[0].removeAttribute('dy');	
	rNode.id = this.id;
	
	$(rNode)
		.attr('class', classes)
		.data('objectid', this.id);
	
	var $mtext = attachMapText(this.id, this.type, this.name, this.svg_x/10, this.svg_y/10);
	if (firstrun === true) $mtext.css('display', 'none');
	
	return this;
	
} //attach()

SymbolClass.prototype.remove = function(){
	
	this.raphaelObject.remove();
	$('#mapText_'+this.id).remove();
	
	return this;
	
} //remove()

//-------------- road "class" -------------------

function RoadClass(id, type, pathstring){
	
	this.id = id;
	this.pathstring = pathstring;
	this.type = type;
	//this.raphaelObject;
	
	return this;
	
} //RoadClass()

RoadClass.prototype.attach = function(){
	
	this.raphaelObject = map.path(this.pathstring);
	
	$(this.raphaelObject.node)
		.attr('class', 't' + this.type)
		.data('objectid', this.id);
	
	return this;
	
} //attach()


RoadClass.prototype.remove = function(){
	
	this.raphaelObject.remove();
	return this;
	
} //remove()

//------------------------------------------------

//map text functions
function attachMapText(id, type, text, xtp, ytp){
	
	var $txtObject = $('<div class="mapText" data-objectid="'+id+'" data-objecttype="'+type+'" id="mapText_'+id+'" style="left: '+(xtp + maptextOffset)+'%; top: '+(ytp - maptextOffset)+'%;">'+text+'</div>');
	$mw.append($txtObject);
	
	return $txtObject;
	
} //showMapText()

//-------------------------

function ajax_getRoadDetails(id){

	$.ajax({
	
		"type": "POST",
		"url": "php/ajax_road_details.php",
		"data": {
			"id": id
		}	
	}).done(function(data){
		setSearchResult(data);
	}).fail(function(xhr){
		setSearchResult("Error (#"+xhr.status+"): "+xhr.statusText);
	});

} //ajax_getRoadDetails()